//mui Ajax 提交和获取json数据
var debug = false;
(function($, owner){
	owner.httpurl = "http://lyzx.kongfanrong.com/index.php/api";
	owner.w = null;
	
	owner.get = function(parameter){
		var target = {
			isloading : false,
			data : {}
		}
		
		$.extend(true, target, parameter);
		if(owner.w){ return; }
		if(target.isloading){
			owner.w = plus.nativeUI.showWaiting();	
		}
		mui.ajax(owner.httpurl + target.url,{				
			dataType : 'json',	//服务器返回json格式数据
			type : 'get',		//HTTP请求类型
			data : target.data,
			success: function(result){
				if(owner.w){
					owner.w.close();
					owner.w=null;
				}
				
				if(debug){ 
					alert(JSON.stringify(result));
				}
				target.callback(result);
			},
			error: function(xhr,type,errorThrown){
				if(owner.w){
					owner.w.close();
					owner.w=null;
				}
				mui.toast("请求失败!"); 
			}
		});
	}

	owner.post = function(parameter){
		var target = {
			iscktoken : false,
			isloading : false,
			data : {}
		}
		
		$.extend(true, target, parameter);
		
		if(target.iscktoken){
			userinfo = user.getUserinfo();
			if(!userinfo){
				return false;
			}
			$.extend(true, target.data, {token : userinfo.token});
		}
//		console.log(JSON.stringify(target));
		//如果有正在加载则返回
		if(owner.w){ return; }
		if(target.isloading){
			owner.w = plus.nativeUI.showWaiting();	
		}							
		mui.ajax(owner.httpurl + target.url, {				
			dataType: 'json',	//服务器返回json格式数据
			data : target.data, 
			type: 'post',		//HTTP请求类型
			success: function(result){

				if(owner.w){
					owner.w.close();
					owner.w=null;
				}
			
				if(debug){
					alert(JSON.stringify(result));
				}
				if(!result.isSuccess && result.message == "001"){
					$.alert("请求参数不正确，请重新登陆!", function(){
						mui.openWindow({
							url : "/pages/acount/login.html", 
							id : "login.html"
						});
					});
					return false;
				}
				if(!result.isSuccess && result.message == "002"){
					$.alert("登录信息已失效，请重新登录!", function(){
						mui.openWindow({
							url : "/pages/acount/login.html", 
							id : "login.html"
						});
					});
					return false;
				}
				
				target.callback(result);
			},  
			error: function(xhr,type,errorThrown){
				if(owner.w){
					owner.w.close();
					owner.w=null;
				} 
				mui.toast("请求失败!"); 
			}
		});
	}
			
}(mui, window.api = {}));

(function($, owner) {
	owner.getUserinfo = function(){
		var state = owner.getState();
//		if(debug){
//			alert(JSON.stringify(state));
//		}		
		if(state.token){
			return state;
		}
												
		mui.openWindow({
			url : "/pages/acount/login.html", 
			id : "login.html"
		});
				
		return false;
	}
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.phone = loginInfo.phone || '';
		loginInfo.password = loginInfo.password || '';
		
		if (loginInfo.phone.trim().length < 1) {
			mui.toast('手机号不能为空!');
			return;
		}
		if (!isMobile(loginInfo.phone)) {
			mui.toast('手机号码不正确!');
			return;
		}
		if (loginInfo.password.length < 6) {
			mui.toast('密码最短为 6 个字符!');
			return;
		}
		
		api.post({
			url : "/user/login",
			isloading : true,
			data : loginInfo, 
			callback : function(result){
				if(result.isSuccess){
					callback(result);
					owner.setState(result.data);
				}else{
					callback(result);
				}			
			}
		});
	};

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		
		
		callback = callback || $.noop;
		
		if (regInfo.phone.length < 1) {
			mui.toast("注册手机号不能为空!"); 
			return;
		}
		if (!isMobile(regInfo.phone)) {
			mui.toast("手机号码不正确!"); 
			return; 
		}
		if (regInfo.code.length < 1) { 
			mui.toast("短信验证码不能为空!"); 
			return;
		}
		if (regInfo.password.length < 6) {
			mui.toast("密码最短需要 6 个字符!"); 
			return;
		}
		
		api.post({ 
			url : "/user/signup", 
			data : regInfo, 
			callback : callback
		});
	};

	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$state') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(data) {
		state = data || {};
		localStorage.setItem('$state', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};	

	/**
	 * 找回密码
	 **/
//	owner.forgetPassword = function(email, callback) {
//		callback = callback || $.noop;
//		if (!checkEmail(email)) {
//			return callback('邮箱地址不合法');
//		}
//		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
//	};

	/**
	 * 获取应用本地配置
	 **/
	owner.setSettings = function(settings) {
		settings = settings || {};
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 设置应用本地配置
	 **/
	owner.getSettings = function() {
		var settingsText = localStorage.getItem('$settings') || "{}";
		return JSON.parse(settingsText);
	}
	
}(mui, window.user = {}));

/* tools */
var g = function(slt){
	return document.querySelector(slt);
}
var isMobile = function(mobile){
	return /^1[358]{1}\d{9}$/.test(mobile);
}
var timeSConvert = function(timestamp){
	var da = new Date();
	if(timestamp){
		da = new Date(timestamp*1000);	
	}
	
	var year = da.getFullYear();
	var month = da.getMonth();
	var date = da.getDate();
	return  [year, month, date].join('-');
}
